\documentclass[../Documentation_Bern_RTOS_PAI]{subfiles}

\begin{document}
\begin{tikzpicture}[bern_rtos_style, color=darkblue]
    \def\headwidth{150mm}
	\def\barwidth{2mm}
	\def\barcorners{0.5mm}

    \node[rectangle, anchor=north west, fill, color=bfhlight, minimum width=\headwidth, minimum height=6.5cm] at (-.2pt,0.5\barwidth) {};
	\draw[rounded corners=\barcorners,color=bfhgrey, fill, line width=0] (0,0) rectangle ++(\headwidth,\barwidth);

    \node[level] (systick) at (1.5,-1.8) {System Tick};
    \node[level, below = \threadlevelsep of systick.south west, anchor=north west] (sched) {Scheduler};
    \node[level, below = \threadlevelsep of sched.south west, anchor=north west] (prio_1) {Priority 1};

    \node[thread, right = \threadfirstsep of systick] (irq_2) {};
    \node[thread] (sched_3) at (sched -| irq_2.east) {};
    \node[thread, minimum width = 3.8*\threadunit] (t_1) at (prio_1 -| sched_3.east) {T1};
    \node[thread] (irq_0) at (systick -| t_1.east) {};
    \node[thread] (sched_0) at (sched -| irq_0.east) {};
    \node[thread, minimum width = 1.5*\threadunit] at (prio_1 -| sched_0.east) (t_2) {T2};
    \node[thread] (sched_1) at (sched -| t_2.east) {};
    \node[thread, minimum width = 2*\threadunit] at (prio_1 -| sched_1.east) (t_3) {T3};
    \node[thread] (irq_1) at (systick -| t_3.east) {};
    \node[thread] (sched_2) at (sched -| irq_1.east) {};
    \node[thread, minimum width = 2*\threadunit] at (prio_1 -| sched_2.east) (t_4) {T1};

    \path[->] 
        (irq_2.south east) edge (sched_3.north west)
        (sched_3.south east) edge (t_1.north west)
        (t_1.north east) edge[interrupt] node {interrupt} (irq_0.south west)
        (irq_0.south east) edge (sched_0.north west)
        (sched_0.south east) edge (t_2.north west)
        (t_2.north east) edge node {yield} (sched_1.south west)
        (sched_1.south east) edge (t_3.north west)
        (t_3.north east) edge[interrupt] node {interrupt} (irq_1.south west)
        (irq_1.south east) edge (sched_2.north west)
        (sched_2.south east) edge (t_4.north west);


    \draw[rounded corners=\barcorners,color=bfhgrey,fill,line width=0] (0,-6.5)  rectangle ++(\headwidth,\barwidth);
    \end{tikzpicture}
\end{document}